% This is another script file to illustrate loops and 
% MATLAB's built-in vectorization
%
clc
disp('                         Loops and Vectorization (cont.)')
disp(' ')
disp('As a second example we perform matrix-vector multiplication')
n = input('Enter size of problem [enter=5000]: ');
if isempty(n)
    n = 5000;
end
A = rand(n);
b = rand(n,1);
disp('How long does a double for-loop take?')
tic;
y = zeros(n,1);
for j=1:n
    for k=1:n
        y(j) = y(j) + A(j,k)*b(k);
    end
end
t1 = toc;
fprintf('Time with for-loop: %f seconds\n\n', t1)

disp('Now vectorized as a series of dot products (with single for-loop):')
tic;
y = zeros(n,1);
for j=1:n
    y(j) = A(j,:)*b;
end
t2 = toc;
fprintf('Time dot products: %f seconds\n\n', t2)

disp('Fully vectorized:')
clear y
tic;
y = A*b;
t3 = toc;
fprintf('Time vectorized: %f seconds\n\n', t3)
